#include<stdio.h>
#include<math.h>

#define PI 3.141592654

main()
{

  int i,no_aus_peaks,no_fer_peaks,aus_h[100],aus_k[100],aus_l[100],fer_h[100],fer_k[100],fer_l[100],aus_hkl2[100],fer_hkl2[100],system_choice,err_opt;
  
  int MF_aus[100],MF_fer[100],option_alloy,iptchoice;
  
  float value,j;
  float aus_peak_2theta[100],fer_peak_2theta[100],aus_peak_theta[100],fer_peak_theta[100], aus_peak_theta_rad[100], fer_peak_theta_rad[100],wavelength;
  
  float sine_by_lambda_fer[100],sine_by_lambda_aus[100],fer_d[100],aus_d[100],aus_a[100],fer_a[100],LPF_aus[100],LPF_fer[100],F_aus[100],F_fer[100],F_aus2[100],F_fer2[100],asc;
  
  float atom_scatter(),e2m_aus[100],e2m_fer[100],IInten_aus[100],IInten_fer[100],inten_aus[100],inten_fer[100],inten_err_aus[100],R_fer[100],R_aus[100],inten_err_fer[100],IbyR_aus[100],IbyR_fer[100],ave_aus,ave_fer,Afer,Aaus, Aus_frac, Fer_frac,inten_err_aus_total,inten_err_fer_total,pre_total_error,total_error;
  char name[200],filename[300],inputfname[100];
  
  FILE *fres, *fentry;
  
  title();
  
  printf("Type the Identification name of the material : \t");
  scanf("%s",name);
  sprintf(filename,"%s_XRD_result",name);
  sprintf(inputfname,".%s_inputs",name);
  getchar();
  if((fentry=fopen(inputfname,"r"))!=NULL)
    {
      printf("\n\nYour input file \"%s\" for the identification name \"%s\" exists\n Do you want to use that (y=1/n=0) ? \t",inputfname,name);
      scanf("%d",&iptchoice);
      if(iptchoice==1)
	{
	    fscanf(fentry,"%s",name);
	    fscanf(fentry,"%f",&wavelength);
	    fscanf(fentry,"%d",&no_aus_peaks);
	    fscanf(fentry,"%d",&no_fer_peaks);
	    fscanf(fentry,"%d",&err_opt);

	    for(i=1;i<=no_aus_peaks;i++)
	      fscanf(fentry,"%f",&aus_peak_2theta[i]);
	    for(i=1;i<=no_fer_peaks;i++)
	      fscanf(fentry,"%f",&fer_peak_2theta[i]);

	    for(i=1;i<=no_aus_peaks;i++)
	      fscanf(fentry,"%f",&IInten_aus[i]);
	    for(i=1;i<=no_fer_peaks;i++)
	      fscanf(fentry,"%f",&IInten_fer[i]);

	    if(err_opt==1)
	      for(i=1;i<=no_aus_peaks;i++)
		fscanf(fentry,"%f",&inten_aus[i]);
	    if(err_opt==1)
	      for(i=1;i<=no_fer_peaks;i++)	    
		fscanf(fentry,"%f",&inten_fer[i]);

	    for(i=1;i<=no_aus_peaks;i++)	     
	      fscanf(fentry,"%d%d%d",&aus_h[i],&aus_k[i],&aus_l[i]);
	    for(i=1;i<=no_fer_peaks;i++)	    
	      fscanf(fentry,"%d%d%d",&fer_h[i],&fer_k[i],&fer_l[i]);


	    fscanf(fentry,"%d",&system_choice);
	    fscanf(fentry,"%d",&option_alloy);
	    
	}
      fclose(fentry);

    }
  else
    printf("Input entries will be logged to \t : %s\n\n", inputfname);


  fentry=fopen(inputfname,"w");
  
  if((fres=fopen(filename,"w"))!=NULL)
    {
      fprintf(fres,"----------------------------------------------------------------------\n");
      fprintf(fres,"\n");
      fprintf(fres,"\t\tCALCULATION OF PHASE FRACTIONS USING XRD DATA\n");
      fprintf(fres,"\n");
      fprintf(fres,"----------------------------------------------------------------------\n");
      
      
      /*--------------- PROGRAM START --------------------------------*/
      
      fprintf(fres, "Material Identification : \t %s", name);
      printf("Enter the wavelength of the X-radiation used:\t");
      if(iptchoice!=1)scanf("%f",&wavelength);
      fprintf(fres, "\n\nWAVELENGTH USED : %f", wavelength);
      printf("\n\nHow many austenite peaks have you got\t:\t");
      if(iptchoice!=1)scanf("%d",&no_aus_peaks);
      printf("How many ferrite peaks have you got\t:\t");
      if(iptchoice!=1)scanf("%d",&no_fer_peaks);
      
      printf("\n\nWhich error estimate fo you prefer\n\n\t1.\tBased on intensities\n\t2.\tBased on Integrated Intensities (recommended)\n\nEnter option:\t");
      if(iptchoice!=1)scanf("%d",&err_opt);
      
      fprintf(fentry, "%s\n%f\n%d\n%d\n%d \n", name,wavelength,no_aus_peaks,no_fer_peaks,err_opt);
      
      
      
      /*******---------------  2-Theta -------------------******/
      
      printf("\n\n--------------THETA VALUES--------------------\n\n");
      fprintf(fres,"\n\n--------------THETA VALUES--------------------\n\n");
      
      for(i=1;i<=no_aus_peaks;i++)
	{
	  printf("Enter the TWO THETA value for peak %d of AUSTENITE:\t",i);
	  if(iptchoice!=1)scanf("%f",&aus_peak_2theta[i]);
	  aus_peak_theta[i]=aus_peak_2theta[i]/2;
	  aus_peak_theta_rad[i]=(PI/180)*aus_peak_theta[i];
	  sine_by_lambda_aus[i]=sin(aus_peak_theta_rad[i])/wavelength;
	  fprintf(fres,"2theta for AUSTENITE : %f\t sin(theta)_by_lambda : %f  ", aus_peak_2theta[i],sine_by_lambda_aus[i]);
	  fprintf(fentry,"%f\n", aus_peak_2theta[i]);
	  fprintf(fres,"\n");
	  printf("\n");
	}
      
      printf("\n\n");fprintf(fres,"\n\n");
      
      
      for(i=1;i<=no_fer_peaks;i++)
	{
	  printf("Enter the TWO THETA value for peak %d of FERRITE:\t",i);
	  if(iptchoice!=1)scanf("%f",&fer_peak_2theta[i]);
	  fer_peak_theta[i]=fer_peak_2theta[i]/2;
	  fer_peak_theta_rad[i]=(PI/180)*fer_peak_theta[i];
	  sine_by_lambda_fer[i]=sin(fer_peak_theta_rad[i])/wavelength;
	  fprintf(fres, "2theta for FERRITE : %f\t sin(theta)_by_lambda : %f  ",fer_peak_2theta[i], sine_by_lambda_fer[i]);
	  fprintf(fentry,"%f\n", fer_peak_2theta[i]);
	  fprintf(fres,"\n");
	  printf("\n");
	}
      
      /*******---------------  INTENSITIES -------------------******/
      
      printf("\n\n--------------INTENSITIES--------------------\n\n");
      fprintf(fres,"\n\n--------------INTENSITIES--------------------\n\n");
      
      
      for(i=1;i<=no_aus_peaks;i++)
	{
	  printf("\nIntegrated Intensity %d for 2-Theta %f of Austenite:\t",i,aus_peak_2theta[i]);
	  if(iptchoice!=1)scanf("%f",&IInten_aus[i]);
	  if(err_opt ==1){
	    fprintf(fres,"Integrated Intensity %d AUSTENITE: %f\n",i, IInten_aus[i]);
	    fprintf(fentry,"%f\n", IInten_aus[i]);
	  }
	}
      fprintf(fres,"\n\n");
      for(i=1;i<=no_fer_peaks;i++)
	{
	  printf("\nIntegrated Intensity %d for 2-Theta %f of ferrite:\t",i,fer_peak_2theta[i]);
	  if(iptchoice!=1)scanf("%f",&IInten_fer[i]);
	  if(err_opt ==1){
	    fprintf(fres,"Integrated Intensity %d FERRITE: %f\n",i, IInten_fer[i]);
	    fprintf(fentry,"%f\n",IInten_fer[i]);	    
	  }
	}
      
      printf("\n\n");
      if(err_opt==1){
	
	printf("\nYou have opted for error calculation using intensities\n\n");
	fprintf(fres,"\nYou have opted for error calculation using intensities\n\n");
	for(i=1;i<=no_aus_peaks;i++)
	  {
	    printf("\nIntensity %d for 2-Theta %f of Austenite:\t",i,aus_peak_2theta[i]);
	    if(iptchoice!=1)scanf("%f",&inten_aus[i]);
	    inten_err_aus[i]=1/sqrt(inten_aus[i]);
	    inten_err_aus_total=inten_err_aus_total+inten_err_aus[i];
	    fprintf(fres,"Intensity %d AUSTENITE: %f\tError : %f \n",i, inten_aus[i],inten_err_aus[i]);
	    fprintf(fentry,"%d\t%f\t%f",i, inten_aus[i],inten_err_aus[i]);
	    
	  }
	for(i=1;i<=no_fer_peaks;i++)
	  {
	    printf("\nIntensity %d for 2-Theta %f of ferrite:\t",i,fer_peak_2theta[i]);
	    if(iptchoice!=1)scanf("%f",&inten_fer[i]);
	    fprintf(fentry,"%f",inten_fer[i]);

	    inten_err_fer[i]=1/sqrt(inten_fer[i]);
	    inten_err_fer_total=inten_err_fer_total+inten_err_fer[i];
	    fprintf(fres,"Intensity %d FERRITE: %f\tError : %f \n",i, inten_fer[i], inten_err_fer[i]);
	  }
	
	
      }
      
      else
	{
	  
	  fprintf(fres,"\nYou have opted for error calculation using  Integrated Intensities\n\n");
	  
	  for(i=1;i<=no_aus_peaks;i++)
	    {
	      inten_err_aus[i]=1/sqrt(IInten_aus[i]);
	      inten_err_aus_total=inten_err_aus_total+inten_err_aus[i];
	      fprintf(fres,"Integrated Intensity %d AUSTENITE: %f\tError : %f \n",i, IInten_aus[i],inten_err_aus[i]);
	      fprintf(fentry,"%f\n", IInten_aus[i]);

	    }
	  
	  for(i=1;i<=no_fer_peaks;i++)
	    {
	      inten_err_fer[i]=1/sqrt(IInten_fer[i]);
	      inten_err_fer_total=inten_err_fer_total+inten_err_fer[i];
	      fprintf(fres,"Integrated Intensity %d FERRITE: %f\tError : %f \n",i, IInten_fer[i], inten_err_fer[i]);
	      fprintf(fentry,"%f\n", IInten_fer[i]);
	    }
	  
	}
      
      /*******---------------  d-spacing -------------------******/
      
      /*printf("\n\n-------------- d-spacing --------------------\n\n");*/
      fprintf(fres,"\n\n-------------- d-spacing --------------------\n\n");
      
      
      for(i=1;i<=no_aus_peaks;i++)
	{
	  aus_d[i]=wavelength/(2*sin(aus_peak_theta_rad[i]));
	  fprintf(fres,"d-spacing for AUSTENITE : %f \n",aus_d[i]);
	}
      for(i=1;i<=no_fer_peaks;i++)
	{
	  fer_d[i]=wavelength/(2*sin(fer_peak_theta_rad[i]));
	  fprintf(fres,"Entered d-spacing for FERRITE : %f \n",fer_d[i]);
	}
      
      /*******---------------  {hkl} -------------------******/
      
      printf("\n\n-------------- INDICES {hkl} --------------------\n\n");
      fprintf(fres,"\n\n-------------- INDICES {hkl} --------------------\n\n");
      
      
      for(i=1;i<=no_aus_peaks;i++)
	{
	  printf("\nEnter the {hkl}  for 2-theta value  %f of AUSTENITE (enter each number with a space):\t", aus_peak_2theta[i]);
	  if(iptchoice!=1)scanf("%d%d%d",&aus_h[i],&aus_k[i],&aus_l[i]);
	  fprintf(fentry,"%d %d %d\n",aus_h[i],aus_k[i],aus_l[i]);
	  
	  aus_hkl2[i]=aus_h[i]*aus_h[i]+aus_k[i]*aus_k[i]+aus_l[i]*aus_l[i];
	  fprintf(fres,"AUSTENITE 2-Theta : %f\t {hkl} : {%d%d%d}\n", aus_peak_2theta[i],aus_h[i],aus_k[i],aus_l[i]);
	  
	}
      for(i=1;i<=no_fer_peaks;i++)
	{
	  printf("\nEnter the {hkl}  for 2-theta value  %f of FERRITE (enter each number with a space):\t",fer_peak_2theta[i]);
	  if(iptchoice!=1)scanf("%d%d%d",&fer_h[i],&fer_k[i],&fer_l[i]);
	  fprintf(fentry,"%d %d %d\n",fer_h[i],fer_k[i],fer_l[i]);

	  fer_hkl2[i]=fer_h[i]*fer_h[i]+fer_k[i]*fer_k[i]+fer_l[i]*fer_l[i];
	  fprintf(fres,"FERRITE 2-Theta : %f\t {hkl} : {%d%d%d}\n", fer_peak_2theta[i],fer_h[i],fer_k[i],fer_l[i]);
	}

      /*******---------------  lattice parameter - a -------------------******/
      
      
      fprintf(fres,"\n\n--------------LATTICE PARAMETER RESULTS--------------------\n\n");
      
      printf("\n\n\n\tLATTICE PARAMETER RESULTS\n\t----------------------\n\n");
      
      
      for(i=1;i<=no_aus_peaks;i++)
	{
	  aus_a[i]=sqrt(aus_d[i]*aus_d[i]*aus_hkl2[i]);
	  printf("\nAUSTENITE [ 2-Theta=%f ]: \t %f",aus_peak_2theta[i],aus_a[i]);
	  fprintf(fres, "\nAUSTENITE [ 2-Theta=%f ]: \t %f",aus_peak_2theta[i],aus_a[i]);
	  
	}
      printf("\n\n");
      for(i=1;i<=no_fer_peaks;i++)
	{
	  fer_a[i]=sqrt(fer_d[i]*fer_d[i]*fer_hkl2[i]);
	  printf("\nFERRITE [ 2-Theta=%f ] : \t %f",fer_peak_2theta[i], fer_a[i]);
	  fprintf(fres,"\nFERRITE [ 2-Theta=%f ] : \t %f",fer_peak_2theta[i], fer_a[i]);
	  
	}
      
      /*******---------------  LORENTZ POLARIZATION FACTOR -------------------******/
      
      fprintf(fres,"\n\n--------------   LORENTZ POLARIZATION FACTOR --------------------\n\n");
      
      
      for(i=1;i<=no_aus_peaks;i++)
	{
	  LPF_aus[i]=(1+cos(2*aus_peak_theta_rad[i])*cos(2*aus_peak_theta_rad[i]))/(sin(aus_peak_theta_rad[i])*sin(aus_peak_theta_rad[i])*cos(aus_peak_theta_rad[i]));
	  fprintf(fres, "AUSTENITE 2-Theta : %f\t LPF [ %d ] : %f \n", aus_peak_2theta[i], i, LPF_aus[i]);
	}
      
      for(i=1;i<=no_fer_peaks;i++)
	{
	  LPF_fer[i]=(1+cos(2*fer_peak_theta_rad[i])*cos(2*fer_peak_theta_rad[i]))/(sin(fer_peak_theta_rad[i])*sin(fer_peak_theta_rad[i])*cos(fer_peak_theta_rad[i]));
	  fprintf(fres, "FERRITE 2-Theta : %f\t LPF [ %d ] : %f \n", fer_peak_2theta[i], i, LPF_fer[i]);
	  
	}
      
      
      /*******---------------  MULTIPLICITY FACTOR -------------------******/
      
      
      fprintf(fres,"\n\n--------------  MULTIPLICITY FACTOR --------------------\n\n");
      
      printf("\n\n\nWhich system_choice are you using\n");
      printf("\n\t1.\tCUBIC\n\t2.\tHEXAGONAL and RHOMBHOHEDRAL\n\t3.\tTETRAGONAL\n\t4.\tORTHORHOMBIC\n\t5.\tMONOCLINIC\n\t6.\tTRICLINIC\n\n");
      printf("Enter option:\t");
      if(iptchoice!=1)scanf("%d",&system_choice);
      fprintf(fentry,"%d\n",system_choice);

      switch(system_choice)
	{
	  
	case 1: printf("\n\nSelected system : CUBIC\n\n");fprintf(fres, "\n\nSelected system : CUBIC\n\n");
	  
	  for(i=1;i<=no_aus_peaks;i++)
	    {
	      printf("Austenite: {%d%d%d}\n",aus_h[i],aus_k[i],aus_l[i]);
	      if(aus_h[i]!=aus_k[i] && aus_k[i] != aus_l[i]) MF_aus[i]=48;
	      if(aus_h[i]==aus_k[i] && aus_k[i] != aus_l[i]) MF_aus[i]=24;
	      if(aus_h[i]==0 && aus_k[i] != aus_l[i]) MF_aus[i]=24;
	      if(aus_h[i]==0 && aus_k[i] == aus_l[i]) MF_aus[i]=12;
	      if(aus_h[i]==aus_k[i] && aus_k[i] == aus_l[i]) MF_aus[i]=8;
	      if(aus_h[i]==0 && aus_k[i] ==0) MF_aus[i]=6;
	      printf("Multipilicity factor [ 2-Theta = %f ]:\t%d\t sin_lambda:\t%f\n",aus_peak_2theta[i],MF_aus[i],sine_by_lambda_aus[i]);
	      fprintf(fres, "Multipilicity factor [ 2-Theta = %f, {%d%d%d} ] : %d\n",aus_peak_2theta[i],aus_h[i], aus_k[i], aus_l[i], MF_aus[i]);
	      
	    }
	  
	  printf("\n\n\n");
	  for(i=1;i<=no_fer_peaks;i++)
	    {
	      printf("Ferrite: {%d%d%d}\n",fer_h[i],fer_k[i],fer_l[i]);
	      if(fer_h[i]!=fer_k[i] && fer_k[i] != fer_l[i]) MF_fer[i]=48;
	      if(fer_h[i]==fer_k[i] && fer_k[i] != fer_l[i]) MF_fer[i]=24;
	      if(fer_h[i]==0 && fer_k[i] != fer_l[i]) MF_fer[i]=24;
	      if(fer_h[i]==0 && fer_k[i] == fer_l[i]) MF_fer[i]=12;
	      if(fer_h[i]==fer_k[i] && fer_k[i] == fer_l[i]) MF_fer[i]=8;
	      if(fer_h[i]==0 && fer_k[i] ==0) MF_fer[i]=6;
	      printf("Multipilicity factor [ 2-Theta = %f ]:\t%d\t sin_lambda:\t%f\n",fer_peak_2theta[i],MF_fer[i],sine_by_lambda_fer[i]);
	      fprintf(fres, "Multipilicity factor [ 2-Theta = %f, {%d%d%d} ] : %d\n",fer_peak_2theta[i],fer_h[i], fer_k[i], fer_l[i], MF_fer[i]);
	      

	    }
	  
	  break;
	  
	case 2: printf("\n\nSelected system : HEXAGONAL and RHOMBHOHEDRAL\n\n");
	  break;
	  
	  
	case 3: printf("\n\nSelected system : TETRAGONAL\n\n");
	  break;
	  
	case 4: printf("\n\nSelected system : ORTHORHOMBIC\n\n");
	  break;
	  
	case 5: printf("\n\nSelected system : MONOCLINIC\n\n");
	  break;
	  
	case 6: printf("\n\nSelected system : TRICLINIC\n\n");
	  break;
	  
	}
      
      /*******---------------  STRUCTURE FACTOR -------------------******/
      
      fprintf(fres,"\n\n--------------  STRUCTURE FACTOR --------------------\n\n");
      printf("\n\n--------------  STRUCTURE FACTOR --------------------\n\n");
      
      printf("\n\nThe major alloying elements in your steel are\t:\n\t1.\tFe only\n\t2.\tFe and Ni\n\t3.\tFe and Cr\n\t4.\tFe, Ni and Cr\n\n\tChoose option:\t");
      if(iptchoice!=1)scanf("%d",&option_alloy);
      fprintf(fentry,"%d\n",option_alloy);

   if (option_alloy==1) 
        fprintf(fres, "Selected system Fe only\n\n");
   else if (option_alloy==2)
	fprintf(fres, "Selected system Fe & Ni only\n\n");
   else if (option_alloy==3)
	fprintf(fres, "Selected system Fe & Cr only\n\n");
   else if (option_alloy==4)
	fprintf(fres, "Selected system Fe, Cr & Ni only\n\n");
 

   for(i=1;i<=no_fer_peaks;i++)
     {
       if((fer_h[i]+fer_k[i]+fer_l[i])%2 == 0) 
	 {
	   asc=atom_scatter(wavelength,option_alloy,sine_by_lambda_fer[i]);
	   F_fer[i]=2*asc;
	   F_fer2[i]=F_fer[i]*F_fer[i];
	   printf("\nFer [ sin_by_lambda %f ] asc=%f \t F2=%f\n",sine_by_lambda_fer[i],asc, F_fer2[i]);
	   fprintf(fres, "Fer [ sin(theta)_by_lambda=%f ]\tAtomic Scatterting factor=%f \t F2=%f\n", sine_by_lambda_fer[i],asc, F_fer2[i]);
	 }
       else
	 F_fer[i]=0;
     }
   
   
   for(i=1;i<=no_aus_peaks;i++)
     {
       if((aus_h[i]+aus_k[i])%2==0 && (aus_h[i]+aus_l[i])%2==0  && (aus_k[i]+aus_l[i])%2==0 )
	 {
	   asc=atom_scatter(wavelength,option_alloy,sine_by_lambda_aus[i]);
	   F_aus[i]=4*asc;
	   F_aus2[i]=F_aus[i]*F_aus[i];
	   printf("\nAus [ sin_by_lambda %f ] asc=%f \t F2=%f\n", sine_by_lambda_aus[i],asc, F_aus2[i]);
	   fprintf(fres, "Aus [ sin(theta)_by_lambda=%f ]\tAtomic Scatterting factor=%f \t F2=%f\n", sine_by_lambda_aus[i],asc, F_aus2[i]);
	 }
       
       else
	 F_aus[i]=0;
     }
   
   printf("\n");
   
   /*******---------------  TEMPERATURE FACTOR -------------------******/
   
   fprintf(fres,"\n\n--------------  TEMPERATURE FACTOR --------------------\n\n");
   
   
   for(i=1;i<=no_aus_peaks;i++)
     {
       e2m_aus[i]=0.150728*pow(sine_by_lambda_aus[i],3)-0.630945*pow(sine_by_lambda_aus[i],2)-0.0277821*sine_by_lambda_aus[i] + 1.00055;
       fprintf(fres,"Austenite e^-2m [ sin(theta)_by_lambda=%f ]: %f\n", sine_by_lambda_aus[i],e2m_aus[i]);
     }
   
   for(i=1;i<=no_fer_peaks;i++)
     {
       e2m_fer[i]=0.150728*pow(sine_by_lambda_fer[i],3)-0.630945*pow(sine_by_lambda_fer[i],2)-0.0277821*sine_by_lambda_fer[i] + 1.00055;
       fprintf(fres,"Ferrite e^-2m [ sin(theta)_by_lambda=%f ]: %f\n", sine_by_lambda_fer[i],e2m_fer[i]);
       
     }
   
   
   /*******---------------  R FACTOR -------------------******/
   fprintf(fres,"\n\n--------------  R FACTOR --------------------\n\n");
   
   
   for(i=1;i<=no_fer_peaks;i++)
     {
       R_fer[i]=(F_fer2[i]*MF_fer[i]*LPF_fer[i]*e2m_fer[i])/pow(fer_a[i],6);
       fprintf(fres,"Ferrite R : %f\n",R_fer[i]);
     }
   
   for(i=1;i<=no_aus_peaks;i++)
     {
       R_aus[i]=(F_aus2[i]*MF_aus[i]*LPF_aus[i]*e2m_aus[i])/pow(aus_a[i],6);
       fprintf(fres,"Austenite R : %f\n",R_aus[i]);
     }
   
   for(i=1;i<=no_aus_peaks;i++)
     {
       IbyR_aus[i]=IInten_aus[i]/R_aus[i];
       Aaus=IbyR_aus[i]+Aaus;
     }
   for(i=1;i<=no_fer_peaks;i++)
     {
       IbyR_fer[i]=IInten_fer[i]/R_fer[i];
       Afer=IbyR_fer[i]+Afer;
     }
   ave_fer=Afer/no_fer_peaks;
   ave_aus=Aaus/no_aus_peaks;
   
   Aus_frac=1/(1+(ave_fer/ave_aus));
   Fer_frac=1-Aus_frac;
   
   fprintf(fres,"\n\n--------------  RESULT --------------------\n\n");
   printf("\n\n--------------  RESULT --------------------\n\n");
   
   pre_total_error=inten_err_aus_total*inten_err_fer_total;
   printf("preT:%f Aus:%f fer:%f",pre_total_error, inten_err_aus_total,inten_err_fer_total);
   total_error=pre_total_error/(1+pre_total_error);
   
   fprintf(fres,"Fraction of Austenite : %f  Ferrite : %f \n",Aus_frac, Fer_frac);
   
   printf("\n\nPercentage of austenite :\t%.3f %%\t Error : %.4f %%", Aus_frac*100,total_error*100);
   printf("\nPercentage of ferrite :\t%.3f %%\t Error : %.4f %%\n\n", Fer_frac*100, total_error*100);
   
   
   fprintf(fres,"\n\nPercentage of austenite :\t%.3f %%\tError : %.4f%%", Aus_frac*100,total_error*100);
   fprintf(fres,"\nPercentage of ferrite     :\t%.3f %%\tError : %.4f %%\n\n", Fer_frac*100, total_error*100);
   
   printf("Look into the filename %s for your results\n\n\t\t\t Thank you for using xrdcalc- Ananth\n", filename);
   fprintf(fres, "-------------------------  END  --------------------------------------");
   fclose(fres);
   fclose(fentry);
    }
  
  else
    printf("%s already exists\n\nPlease rename it and then run this program\n\n", filename);
  
}



float atom_scatter(lambda,opt,sin_by_lambda)
int opt;
float sin_by_lambda,lambda;
{
float ffe,fni,fcr, f, f_err,ratio_lambda;

ffe=298.541*pow(sin_by_lambda,7)-1416.84*pow(sin_by_lambda,6)+2708.46*pow(sin_by_lambda,5)-2647.53*pow(sin_by_lambda,4)+1369.02*pow(sin_by_lambda,3)-323.115*pow(sin_by_lambda,2)-8.21796*sin_by_lambda+26.0038;

fni=164.627*pow(sin_by_lambda,7)-881.92*pow(sin_by_lambda,6)+1866.91*pow(sin_by_lambda,5)-1994.09*pow(sin_by_lambda,4)+1115.99*pow(sin_by_lambda,3)-281.002*pow(sin_by_lambda,2)-11.5068*sin_by_lambda+28.0041;

fcr=255.541*pow(sin_by_lambda,7)-1208.95*pow(sin_by_lambda,6)+2301.11*pow(sin_by_lambda,5)-2237.69*pow(sin_by_lambda,4)+1149.36*pow(sin_by_lambda,3)-266.194*pow(sin_by_lambda,2)-11.4846*sin_by_lambda+23.9948;

switch(opt)
{
case 1: f=ffe;break;
case 2: f=(ffe+fni)/2;printf("\n[ %f ]Selected Fe and Ni \tffe=%f fni=%f f = %f",sin_by_lambda,ffe,fni,f);break;
case 3: f=(ffe+fcr)/2;break;
case 4: f=(ffe+fcr+fni)/3;break;
}

ratio_lambda=lambda/1.74346;

if (ratio_lambda <= 1)
{
f_err=-33745.3*pow(ratio_lambda,10) + 158121*pow(ratio_lambda,9) - 314972*pow(ratio_lambda,8) + 347441*pow(ratio_lambda,7) - 231665*pow(ratio_lambda,6) + 95617.5*pow(ratio_lambda,5) - 24013.6*pow(ratio_lambda,4) + 3450.3*pow(ratio_lambda,3) - 248.253*pow(ratio_lambda,2) + 7.56109*ratio_lambda + 0.0341823;

printf("\nError Associated [ratio_lambda = %f ]\t:\t%f\n",ratio_lambda ,f_err);
}
else if (ratio_lambda > 1 && ratio_lambda <= 1.13)
{
f_err=327.877*pow(ratio_lambda,7)-3700.62*pow(ratio_lambda,6)+17745.5*pow(ratio_lambda,5)-46856.2*pow(ratio_lambda,4)+73564.1*pow(ratio_lambda,3)-68668*pow(ratio_lambda,2)+35288.7*ratio_lambda-7705.91 ;

printf("\nError Associated [ratio_lambda = %f ]\t:\t%f\n",ratio_lambda ,f_err);

}
else if (ratio_lambda > 1.13) 
{
f_err=2.31485*pow(ratio_lambda,6)-19.2679*pow(ratio_lambda,5)+61.2172*pow(ratio_lambda,4)-87.0473*pow(ratio_lambda,3)+38.6116*pow(ratio_lambda,2)+28.3705*ratio_lambda-27.3772;
printf("\nError Associated [ratio_lambda = %f ]\t:\t%f\n",ratio_lambda ,f_err);

}

return(f+f_err);
}

title()
{
printf("----------------------------------------------------------------------\n");
printf("\n");
printf("\t   CALCULATION OF PHASE FRACTIONS USING XRD DATA\n\n");
printf("----------------------------------------------------------------------\n\n\n\n");
printf("\n\n\n\t\t\t    By\n\t\t\tMurugananth M\n\t\tPhase Transformation Group\n\t\t  University of Cambridge\n\n\n\n");



}
